{{
LineRAM based display test for 240H composite NTSC output, single COG
(c) Eric Ball Creative Commons Attribution-ShareAlike 3.0 License
}}
CON
  ' Set up the processor clock in the standard way for 80MHz
  _XINFREQ = 5_000_000 + 0000                           ' Demoboard
  _CLKMODE = XTAL1 + PLL16X                             ' Demoboard                                                     
'  _XINFREQ = 10_000_000 + 0000                          ' Hydra
'  _CLKMODE = XTAL1 + PLL8X                              ' Hydra
'  _XINFREQ = 6_000_000 + 0000                           ' Hybrid
'  _CLKMODE = XTAL1 + PLL16X                             ' Hybrid
  
PUB start

  COGINIT( COGID, @cogstart, @cogstart )

DAT
                        ORG $0
cogstart                MOV     FRQA, ifrqa             ' set CTRA to 7.159MHz / 80MHz * 2^32
                        MOVI    CTRA, #%0_00001_111     ' PLL internal mode, x16 PLLA = 114.54545MHz
                        MOV     VCFG, ivcfg             ' VGA mode, 2 bits/pixel, P12-15 output
                        MOV     DIRA, idira             ' P12-15 output
                        MOV     VSCL, vscl1             ' set VSCL to 1 clock / frame (instant update)
                        WAITVID sync, #0                ' wait for 4096 PLLA clocks to expire
                        MOVI    CTRA, #%0_00001_100     ' set PLLA x2 = 14.31818MHz
                        MOVS    VSCL, #56               ' set VSCL so it reloads on first WAITVID (56 = #CPU cycles)
nextrow                 ADD     rownum, #1
                        CMPSUB  rownum, #262
                        CMP     rownum, #240    WC,WZ
        IF_C            JMP     #doactive
                        CMP     rownum, #250    WC
        IF_NC_OR_Z      JMP     #doblank

dovsync                 CMP     rownum, #244    WZ
        IF_NZ           CMP     rownum, #245    WZ
        IF_NZ           CMP     rownum, #246    WZ
                        MOV     count1, #2
:half   IF_NZ           MOVS    VSCL, #33               ' 34 PLLA @ -40 IRE (equalizing pulse)
        IF_Z            MOVS    VSCL, #388              ' 388 PLLA @ -40 IRE (serration pulse)
                        WAITVID sync, #0                ' start at end of current line
        IF_NZ           MOVS    VSCL, #422              ' 421 PLLA @ 0 IRE (equalizing pulse)
        IF_Z            MOVS    VSCL, #67               ' 67 PLLA @ 0 IRE (serration pulse)
                        WAITVID sync, blank
                        DJNZ    count1, #:half
                        JMP     #nextrow

doblank                 MOVS    VSCL, #67               ' 67 PLLA @ -40 IRE (sync pulse)
                        WAITVID sync, #0
                        TEST    rownum, #1      WZ      ' even or odd row
        IF_Z            MOVS    :burst, #%%2123         ' rising -U burst
        IF_NZ           MOVS    :burst, #%%2321         ' falling -U burst
                        MOVS    VSCL, #9                ' 9 PLLA @ 0 IRE (blank)
                        WAITVID sync, blank
                        MOV     count1, #9
                        MOVS    VSCL, #4                ' 4 pixels (one cycle) per frame
:burst                  WAITVID sync, #%%2123           ' 36 PLLA: 9 cycles colorburst
                        DJNZ    count1, #:burst
                        MOV     VSCL, vscl798           ' 798 PLLA @ 0 IRE (blank)
                        WAITVID sync, blank
                        MOV     VSCL, vscl1             ' clear high bits of frame counter
                        JMP     #nextrow

doactive                MOV     VSCL, #67               ' 67 PLLA @ -40 IRE (sync pulse)
                        WAITVID sync, #0
                        TEST    rownum, #1      WZ      ' even or odd row
        IF_Z            MOVS    :burst, #%%2123         ' rising -U burst
        IF_NZ           MOVS    :burst, #%%2321         ' falling -U burst
        IF_Z            MOV     :pixel0, evenp0         ' set colorburst phase & init pointers
        IF_NZ           MOV     :pixel0, oddp0
        IF_Z            MOV     :pixel1, evenp1
        IF_NZ           MOV     :pixel1, oddp1
        IF_Z            MOV     :pixel2, evenp2
        IF_NZ           MOV     :pixel2, oddp2
        IF_Z            MOV     :pixel3, evenp3
        IF_NZ           MOV     :pixel3, oddp3
                        MOVS    VSCL, #9
                        WAITVID sync, blank             ' 9 PLLA @ 0 IRE (blank)
                        MOV     count1, #9
                        MOVS    VSCL, #4                ' 4 pixels (one cycle) per frame
:burst                  WAITVID sync, #%%2123           ' 9 cycles colorburst
                        DJNZ    count1, #:burst
                        MOVS    VSCL, #38
                        WAITVID sync, blank             ' 38 PLLA @ 0 IRE (blank)
                        MOV     count1, #240/4
                        MOVS    VSCL, #3                ' 3 PLLA per frame (4.77MHz)
:active                 ADD     :pixel0, d4             ' 720 PLLA active video (240 pixels)
:pixel0                 WAITVID lineram+0, #%%012       ' Y+U Y-V Y-U
                        ADD     :pixel1, d4             ' note: doesn't take effect until next loop
:pixel1                 WAITVID lineram+1, #%%123       ' Y-V Y-U Y+V
                        ADD     :pixel2, d4
:pixel2                 WAITVID lineram+2, #%%230       ' Y+U Y-V Y-U
                        ADD     :pixel3, d4
:pixel3                 WAITVID lineram+3, #%%301       ' Y+V Y+U Y-V
                        DJNZ    count1, #:active
                        WAITVID sync, blank             ' 3 PLLA @ 0 IRE (blank)
                        MOVS    VSCL, #37
                        WAITVID sync, blank             ' 37 PLLA @ 0 IRE (blank)
                        JMP     #nextrow

evenp0                  WAITVID lineram+0, #%%012       ' +U -V -U
evenp1                  WAITVID lineram+1, #%%123       ' +V +U -V
evenp2                  WAITVID lineram+2, #%%230       ' -U +V +U
evenp3                  WAITVID lineram+3, #%%301       ' -V -U +V

oddp0                   WAITVID lineram+0, #%%230       ' -U +V +U
oddp1                   WAITVID lineram+1, #%%301       ' -V -U +V
oddp2                   WAITVID lineram+2, #%%012       ' +U -V -U
oddp3                   WAITVID lineram+3, #%%123       ' +V +U -V


ifrqa                   LONG    $16E8BA2F               ' Demoboard & Hydra
'ifrqa                   LONG    $131745D1               ' Hybrid
ivcfg                   LONG    %0_01_1_0_0_111_00000000000_001_0_01110000      ' Demoboard
'ivcfg                   LONG    %0_01_1_0_0_111_00000000000_011_0_00000111      ' Hydra & Hybrid
idira                   LONG    $00007000               ' Demoboard
'idira                   LONG    $07000000               ' Hydra & Hybrid
vscl1                   LONG    1<<12+1                 ' 1 PLLA per pixel, 1 PLLA per frame
vscl798                 LONG    798                     ' 798 PLLA per frame
count1                  LONG    $63697245               ' multipurpose counter
rownum                  LONG    240                     ' current row (0 = first active row)
blank                   LONG    %%2222222222222222      ' 16 pixels, color = 2 (blank)
d4                      LONG    4<<9                    ' opcode Dest field = 4

sync                    LONG    $33221100               ' 20IRE 0IRE -20IRE -40IRE (lsb)
                        FIT     $100
'                       LONG    Y+V_Y+U_Y-V_Y-U         ' CLUT format bit[7-4] = bit[3-0] = 40IRE 80IRE 40IRE 20IRE (lsb)
lineram                 LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $66776655
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $77665566
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $66556677
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55667766
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $77553355
                        LONG    $77553366
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $55775533
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355
                        LONG    $77553355

